<?php

 /* script returns certain Incoming\Outgoing traffic on certain interface on unix/linux machines via snmp protocol
    script uses snmpcounter.php for snmp data retrieval
    usage: "php interface_traffic.php"
    note to cacti users: this technique boosts cacti poller performance up to 10 times in comparisson to perl scripts containing external snmpget calls.
    the only requirement is to build php with snmp support, otherwise performance will be similar as in perl case.
    author: amnesiac@netzond.com
 */

 include('snmpcounter.php');

 $ip='127.0.0.1';
 $com='public';
 $oid_in='interfaces.ifTable.ifEntry.ifInOctets.2';
 $oid_out='interfaces.ifTable.ifEntry.ifOutOctets.2';

 $counter['prev_in']=snmp_data($ip,$com,$oid_in);
 $counter['prev_out']=snmp_data($ip,$com,$oid_out);
 sleep(REFRESH_INTERVAL);
 $counter['curr_in']=snmp_data($ip,$com,$oid_in);
 $counter['curr_out']=snmp_data($ip,$com,$oid_out);
 
 $traffic_in=floor(MULTIPLIER*($counter['curr_in'][0] - $counter['prev_in'][0]) / ($counter['prev_in'][1]/2+$counter['prev_out'][1]+$counter['curr_in'][1]/2+REFRESH_INTERVAL));
 $traffic_out=floor(MULTIPLIER*($counter['curr_out'][0] - $counter['prev_out'][0]) / ($counter['prev_out'][1]/2+$counter['curr_in'][1]+$counter['curr_out'][1]/2+REFRESH_INTERVAL));
 
 printf("%s\n%s\n",$traffic_out,$traffic_in);

?>
