<?php
 /* script returns certain snmp values on unix/linux machines, such as traffic or any other time-dependent counters(gauges)
    basicaly it does the following: gets snmp counter, waits for desired period of time, gets refreshed counter value and calculates:
    traffic = (newValue - oldValue)*8/(sleep time)
    script uses snmpcounter.php for snmp data retrieval
    usage: "php gather.php 127.0.0.1 public .1.3.6.1.2.1.2.2.1.10.1"
                             - will return traffic, passing chosen network interface
    please note - for snmp data, which doesn't require calculations, use of this scrip is pointless
    author: amnesiac@netzond.com
 */

include('snmpcounter.php');

if (!empty($_REQUEST)) {
    $ip=$_REQUEST['ip']; 
    $oid=$_REQUEST['oid'];
    $com=$_REQUEST['community'];
    if (empty($ip) || empty($oid) || empty($com)) 
	die ("usage: ".$_SERVER['PHP_SELF']."?ip=".$_SERVER['HTTP_HOST']."&oid=.1.3.6.1.2.1.2.2.1.10.1&community=public");
} elseif (!empty($_SERVER["argv"])) {
    $ip=$_SERVER["argv"][1];
    $com=$_SERVER["argv"][2];
    $oid=$_SERVER["argv"][3];
    if (empty($ip) || empty($oid) || empty($com)) 
	die ("usage: php ".$_SERVER["argv"][0]." ip oid community\n");
} else {
    die ("ERROR! no parameters entered");
}

 $counter['prev']=snmp_data($ip,$com,$oid);
 sleep(REFRESH_INTERVAL);
 $counter['curr']=snmp_data($ip,$com,$oid);
 $result=floor(MULTIPLIER*($counter['curr'][0] - $counter['prev'][0]) / ($counter['prev'][1]/2+$counter['curr'][1]/2+REFRESH_INTERVAL))."\n";
 echo $result;
?>
